LeetCode 283 - Move Zeroes


Techinpad: [LeetCode] Move Zeroes
Given an array nums, write a function to move all 0's to the end of it while maintaining the relative order of the non-zero elements.
For example, given nums = [0, 1, 0, 3, 12], after calling your function, nums should be [1, 3, 12, 0, 0].
Note:
  1. You must do this in-place without making a copy of the array.
  2. Minimize the total number of operations.
https://discuss.leetcode.com/topic/29902/1ms-java-solution/6
// Loop through nums, if nums[i] is non-zero, replace the leftmost 
// zero element nums[j] with nums[i] and set nums[i] to zero if i > j. 
// Note that i == j happens when nums has leading non-zero 
// elements, nums = {2, 1, 3, 0, 5, 0, 6}. In this case, we don't perform
// any swap and keep incrementing i and j until i > j.

public void moveZeroes(int[] nums) {
    int j = 0; // The index of the leftmost zero in nums.
    for(int i = 0; i < nums.length; i++){
        if(nums[i] != 0){
            if(i > j){ // i can only be larger than or equal to j.
                nums[j] = nums[i];
                nums[i] = 0;
            }
            j++;
        }
    }
}
Inspired by your code, this is my implementation that doesn't use the temp variable and avoids unnecessary swaps when nums has leading non-zero element.

https://segmentfault.com/a/1190000003768716
http://buttercola.blogspot.com/2015/09/leetcode-move-zeroes.html
https://discuss.leetcode.com/topic/24716/simple-o-n-java-solution-using-insert-index/11
实际上就是将所有的非0数向前尽可能的压缩,最后把没压缩的那部分全置0就行了。比如103040,先压缩成134,剩余的3为全置为0。过程中需要一个指针记录压缩到的位置。
    public void moveZeroes(int[] nums) {
        int cnt = 0, pos = 0;
        // 将非0数字都尽可能向前排
        for(int i = 0; i < nums.length; i++){
            if(nums[i] != 0){
                nums[pos]= nums[i];
                pos++;
            }
        }
        // 将剩余的都置0
        for(;pos<nums.length; pos++){
            nums[pos] = 0;
        }
    }
https://discuss.leetcode.com/topic/32632/a-95-26-beat-rate-solution
    public void moveZeroes(int[] nums) {
        int j = 0;
        for (int num : nums)
            if (num != 0) nums[j++] = num;
        Arrays.fill(nums, j, nums.length, 0);
    }
https://gist.github.com/gcrfelix/76e265bdc5407fad7d2d
第一种,如果数组中大部分是0的情况,使用remove dups的解法,这样移动次数最少
public int moveZeros(int[] nums) {
  if(nums == null || nums.length == 0) {
    return;
  }
  int index = 0;
  for(int i=0; i<nums.length; i++) {
    if(nums[i] != 0) {
      nums[index++] = nums[i];
    }
  }
  return nums.length - index;
}

public void moveZeroes(int[] nums) { int j = 0; for(int i = 0; i < nums.length; i++) { if(nums[i] != 0) { int temp = nums[j]; nums[j] = nums[i]; nums[i] = temp; j++; } } }
X. http://blog.csdn.net/sbitswc/article/details/48706065


two pointers, one point to first zero element, second point to following first non-zero element.
    public void moveZeroes(int[] nums) {
        if(nums.length<=1) return;
        int first = 0;
        int sec = 0;
        while(sec<nums.length) {
            //find first zero element
            while(first<nums.length && nums[first] !=0) {
                first++;
            }
            if(first == nums.length) return;
            sec = first+1;
            //find following first non-zero element
            while(sec<nums.length && nums[sec] == 0){
                sec++;
            }
            if(sec == nums.length) return;
            swap(nums, first, sec);
        }
    }
    public void swap(int[] nums, int i, int j) {
        int temp = nums[i];
        nums[i] = nums[j];
        nums[j] = temp;
    }
第二种情况,如果数组中大部分是非0的情况,以上方法会让大部分数字重新赋值,所以移动次数多
这时候我们可以采用类似sort colors的做法,使用two pointers使移动次数最少
但是这种方法会打乱原数组的relative order
public int moveZeros(int[] nums) {
  if(nums == null || nums.length == 0) {
    return 0;
  }
  int left = 0;
  int right = nums.length - 1;
  while(left <= right) {
    while(left<=right && nums[left]!=0) {
      left ++;
    }
    while(left<=right && nums[right]==0) {
      right--;
    }
    if(left<right) {
      int temp = nums[left];
      nums[left] = nums[right];
      nums[right] = temp;
    }
  }
  return nums.length - left;
}

  1.     void moveZeroes(vector<int>& nums) {  
  2.         int size = nums.size();  
  3.         if(size<=1) return;  
  4.         int s = 0, e = 0;  
  5.           
  6.         while(s<size) {  
  7.             while( s < size && nums[s] == 0) {  
  8.                 s++;  
  9.             }  
  10.             if(s == size) break;  
  11.               
  12.             swap(nums[s], nums[e]);  
  13.             e++;  
  14.             s++;  
  15.         }  
  16.         return;  
  17.     } 
http://blog.welkinlan.com/2015/09/20/move-zeroes-leetcode-java/
    public void moveZeroes(int[] nums) {
        if (nums == null || nums.length == 0) {
            return;
        }
        int numOfNonZero = 0;
        for (int i = 0; i < nums.length; i++) {
            if (nums[i] != 0) {
               swap(i, numOfNonZero, nums);
               numOfNonZero++;
            }
        }
    }
    
    private void swap (int i, int j, int[] nums) {
        int t = nums[i];
        nums[i] = nums[j];
        nums[j] = t;
    }

Q:如果要把所有的0放在前面而不是后面呢?
A:同样的解题思路,但是是从后向前遍历,将非0数字压缩到后面。

http://blog.gainlo.co/index.php/2016/11/18/uber-interview-question-move-zeroes/
If you think more about the above solution, there are some redundant operations. When we traverse the array, we don’t really need to finish every single number. When we already reach the last count numbers, there’s no need to check zeroes as all of them should be set to 0.
In other words, the iteration should finish when index i >= count.
First of all, instead of using a counter, we simply use the right pointer that points to the right end of the array, which works exactly the same in essence. Therefore, when left >= right, we can just put everything to 0. This removes redundant operations.
A couple of things you should be careful about the code:
  • Validating inputs should always be the first thing in your mind.
  • Be cautious about whether it’s left <= right or left < right. (If you use left <= right, you’ll have trouble with input like [1, 2])
  • Personally, I’d like to keep code concise. So I won’t add if array[left] == 0 before the swapping.
  • In fact, this method modifies the array in-place. Therefore, there’s no need to return the array.

https://github.com/mintycc/OnlineJudge-Solutions/blob/master/Leetcode/283_Move_Zeros.java
    public void moveZeroes(int[] nums) {
        int now = 0;
        for (int num : nums)
            if (num != 0)
                nums[now ++] = num;
        while (now < nums.length)
            nums[now ++] = 0;
    }

    public void moveZeroes(int[] nums) {
        int j = 0;
        for (int i = 0; i < nums.length; i ++)
            if (nums[i] != 0) {
                if (i == j) j ++;
                else {
                    nums[j ++] = nums[i];
                    nums[i] = 0;
                }
            }
    }
1. Follow up 1 - 输出零的数量量
2. 如何保证⾮非零数的顺序
3. with least write


Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts